
function RGB2Hex(r:uint, g:uint, b:uint ):uint {
	var hex : uint = r << 16 ^ g << 8 ^ b;
	return hex;
}

function init():void {
	//xml			
	loader = new URLLoader();
	loader.load(new URLRequest(url));
	loader.addEventListener(Event.COMPLETE, onCompleteXML);	
}

function onCompleteXML(event:Event):void{
	text_xml = new XML(loader.data);
	if(text_xml.options[0].@output == "true") {
		stage.addChild(new Output());
		o = true;
	} else {
		o = false;
	}
	//3d prep
	
	camera.zoom = text_xml.options[0].@zoom;
	camera.focus = text_xml.options[0].@focus;
	addChild(view);
	theLight = new PointLight3D(true);
	theLight.x = -200;
	theLight.y = -200;
	theLight.z = 200;
	theLight2 = new PointLight3D(true);
	theLight2.x = 200;
	theLight2.y = 200;
	theLight2.z = -200;	
	
	fx = new EffectLayer();
   	view.addRenderLayer(fx);
	
	split_offset = 0;
	i = 0;
	obj = new Array();	
	
	//load img
	if(o){Output.trace("XML loaded, Continuing.");};
	loader.removeEventListener(Event.COMPLETE, onCompleteXML);
	img = new Loader();
	img.load(new URLRequest(text_xml.options[0].@src));
	img.contentLoaderInfo.addEventListener(Event.COMPLETE, initAscii);
}

function loadImage(url:String):Loader {
	if(o){Output.trace("Image loaded, Continuing.");};
	var ldr:Loader = new Loader();
	var urlReq:URLRequest = new URLRequest(url);
	ldr.load(urlReq);
	return ldr;
}

function initAscii(event:Event):void{
	
	if(o){Output.trace("Ascii Conversion Starting.");};
	var _img:Bitmap = Bitmap(img.contentLoaderInfo.content);
	_data = _img.bitmapData;
	_whiteThreshold = 0xFF;
	_blackThreshold = 0x00;
	var hexVal:uint;
	var rgbVal:uint;
	var argbVal:uint;
	var alphaVal:uint;
	var redVal:uint;
	var greenVal:uint;
	var blueVal:uint;
	var grayVal:uint;
	var index:uint;
	
	if(text_xml.options[0].@original == "true") addChild(img);
	
	rootNode = new DisplayObject3D();
	
	_resolution = text_xml.options[0].@resolution;
	/* 
	* Determine the "resolution" (dimensions) of the resulting "image" (the number
	* of rows of text, and the number of characters per row):
	*/
	var verticalResolution:uint = Math.floor(_data.height * _resolution); 
	/* 
	* Since the "pixels" (characters) aren't square, multiply by 0.45 to maintain the
	* scale of the original image:
	*/
	var horizontalResolution:uint = Math.floor(_data.width * _resolution * 0.45);
	
	var result:String = "";
	// Loop through the rows of pixels top to bottom:
	
		
 		
	if(text_xml.options[0].@blur_fx == 0)
	{	
		bfx = new BitmapEffectLayer(stage.width, stage.height, true, 0, "clear_pre", false, true);
 	} else {
 		bfx = new BitmapEffectLayer(stage.width, stage.height);
		bfx.addEffect(new BitmapLayerEffect(new BlurFilter(text_xml.options[0].@blur_fx, text_xml.options[0].@blur_fx, text_xml.options[0].@blur_fx)));
 	}
 	view.addRenderLayer(bfx);	
	for (var y:uint = 0; y < _data.height; y += verticalResolution)
 	{
		// Within each row, loop through the individual pixels left to right:
		for (var x:uint = 0; x < _data.width; x += horizontalResolution)
		{
			// Extract individual red, green, and blue values for the pixel:
			rgbVal = _data.getPixel(x, y);
			argbVal = _data.getPixel32(x, y);
			alphaVal = (argbVal >> 24) & 0xFF;
			redVal = (rgbVal >> 16) & 0xFF;
			greenVal = (rgbVal >> 8) & 0xFF;
			blueVal = rgbVal & 0xFF;
			
			var hex_color:String = rgbVal.toString(16).toUpperCase();
		    while(hex_color.length < 6){
		        hex_color = "0" + hex_color;
		    }
		    var ahex_color:String = argbVal.toString(16).toUpperCase();
		    while(ahex_color.length < 8){
		        ahex_color = "0" + ahex_color;
		    }
		    
			ahex_color = "0x"+ ahex_color;			
			hex_color = "0x" + hex_color;
			
			/* 
			* Calculate the gray value of the pixel.
			* The formula for grayscale conversion: (Y = gray): Y = 0.3*R + 0.59*G + 0.11*B
			*/
			grayVal = Math.floor(0.3 * redVal + 0.59 * greenVal + 0.11 * blueVal);
			
			/* 
			* The white threshold and black threshold values (read from the "images.txt" file)
			* determine the grayscale values that are the cut-off limits for white and black.
			* Values outside the threshold will be "rounded" to pure white or black.
			*/
			if (grayVal > _whiteThreshold)
			{
				grayVal = 0xFF;
			}
			else if (grayVal < _blackThreshold)
			{
				grayVal = 0x00;
			}
			else
			{
				/* Normalize the grayscale value along the relative scale between the white threshold
				* and the black threshold. In other words, adjust the palette so that
				* the black threshold acts as the "0x00" value and the white threshold acts as the "0xFF" value,
				* then determine where the gray value falls along that scale:
				*/
				grayVal = Math.floor(0xFF * ((grayVal - _blackThreshold) / (_whiteThreshold - _blackThreshold)));
			}
			/* The value is now a gray value in the 0-255 range, which needs to be converted
			* to a value in the 0-64 range (since that's the number of available "shades of gray"
			* in the set of available characters):
			*/
			index = Math.floor(grayVal / 4);
			result += palette.charAt(index);
			
			//shape variables
			var my_size:Number =10* Number(text_xml.options[0].@size_mod); 
			var my_x:Number = ((x*10 * -1)*Number(text_xml.options[0].@spacing_mod)) + Number(text_xml.options[0].@mod_x);
			var my_y:Number = ((y*10 )*Number(text_xml.options[0].@spacing_mod)) + Number(text_xml.options[0].@mod_y);
			
			//material													
			var ml:MaterialsList = new MaterialsList();
			var mat:MaterialObject3D = new MaterialObject3D();
			mat.doubleSided = false;
			switch(String(text_xml.options[0].@mtype))
			{
				case "wireframe":									
					mat = new WireframeMaterial(Number(hex_color), 0.75, 1);	
					ml.addMaterial(mat, "all");
					break;
				case "solid":															
					mat = new ColorMaterial(Number(hex_color));	
					ml.addMaterial(mat, "all");
					break;
				case "phong":															
					mat = new PhongMaterial(theLight, 0xFFFFFF, Number(hex_color), 0x000000);
					ml.addMaterial(mat, "all");
					break;
				case "gouraud":															
					mat = new GouraudMaterial(theLight2, 0xFFFFFF, Number(hex_color));
					ml.addMaterial(mat, "all");
					break;
				case "flat":															
					mat = new FlatShadeMaterial(theLight2, 0xFFFFFF, Number(hex_color));
					ml.addMaterial(mat, "all");
					break;
				case "cell":															
					mat = new CellMaterial(theLight2, 0xFFFFFF, Number(hex_color), 6);
					ml.addMaterial(mat, "all");
					break;
				case "none":
                    mat = new WireframeMaterial(Number(hex_color), 0, 1);
                    ml.addMaterial(mat, "all");
					break;
				default:
					break;
			}
			
			
			//shapes
			obj[i] = new Object();
			switch(palette.charAt(index))
			{
				case "#":
					my_size*=1.25;
					if(text_xml.options[0].@mtype !== "none")
					{
						
					  obj[i].img = new Cube(
        				ml,
        				my_size,
        				my_size,
        				my_size,
        				1*Number(text_xml.options[0].@poly_mod),
        				1*Number(text_xml.options[0].@poly_mod),
        				1*Number(text_xml.options[0].@poly_mod),
        				0,
        				0,
        				{
	        				y: my_x,
	        				x: my_y
	        			}
	        		 );
	    			}
					break;
				case "x":
					my_size *= 0.8
					if(text_xml.options[0].@mtype !== "none") 
					{
					
					 obj[i].img = new Cylinder(
        				mat,
        				my_size,
        				my_size,
        				3*Number(text_xml.options[0].@poly_mod),
        				1*Number(text_xml.options[0].@poly_mod),
        				my_size,
        				{
	        				y: my_x,
	        				x: my_y
	        			}
	        		 );
	    			}
					break;
				case "c":
					my_size *= 0.75
					if(text_xml.options[0].@mtype !== "none") 
					{
					 obj[i].img = new Sphere(
        				mat,
        				my_size,
        				3*Number(text_xml.options[0].@poly_mod),
        				1*Number(text_xml.options[0].@poly_mod),
        				{
	        				y: my_x,
	        				x: my_y
	        			}
	        		 );
				    }
					break;
				case "t":
					my_size *= 0.75
					if(text_xml.options[0].@mtype !== "none") 
					{
					 obj[i].img = new Cone(
        				mat,
        				my_size,
        				my_size,
        				2*Number(text_xml.options[0].@poly_mod),
        				1*Number(text_xml.options[0].@poly_mod),
        				{
	        				y: my_x,
	        				x: my_y
	        			}
	        		 );
	    			}
					break;
				case ".":
					my_size *= 0.45;
					if(text_xml.options[0].@mtype !== "none")
					{
					 obj[i].img = new Sphere(
        				mat,
        				my_size,
        				2*Number(text_xml.options[0].@poly_mod),
        				1*Number(text_xml.options[0].@poly_mod),
        				{
	        				y: my_x,
	        				x: my_y
	        			}
	        		 );
	    			}
					break;
				default:
					break;
			}
			
			if(text_xml.options[0].@mtype == "none") {
			
				obj[i].img = obj[i].img = new Cube(
					ml,
					my_size,
					my_size,
					my_size,
					1,
					1,
					1,
					0,
					0,
					{
	    				y: my_x,
	    				x: my_y
	    			}
	    		);
	  		}
			
			//invisible if the image alpha is less than only 20
			if(Number(alphaVal.toString(16).toUpperCase()) <= 20)
			{
				obj[i].img.visible = false;
			}
			
			
			if(Number(text_xml.options[0].@pixel_fx) !== 0)
			{
				pixels = new Pixels( bfx );			
	            for(yy = 0; yy < my_size*text_xml.options[0].@pixel_fx; yy++)
				{
	                var pX:int = (Math.random() * my_size) - (Math.random() * my_size);
	                var pY:int = (Math.random() * my_size) - (Math.random() * my_size);
            	    pixels.addPixel3D(new Pixel3D( uint(Number(ahex_color)) , pX,pY,0 ));
	            }
	            obj[i].hex_color = hex_color;
	            obj[i].ahex_color = ahex_color;
	            obj[i].my_size = my_size;
	            obj[i].img.material.renderLayer = bfx;
				obj[i].img.addChild( pixels );
			} 
			rootNode.addChild(obj[i].img);
		}
		//result += "\n";
	}
	
	rootNode.rotationX = -90;
	rootNode.rotationZ = -45;
	scene.addChild(rootNode);
	if(o){Output.trace("Ascii conversion complete, Continuing.");};
	
	addEventListener( Event.ENTER_FRAME, enterFrameHandler ); 
	
}

function enterFrameHandler( event : Event ):void {
	/*
	var d:Number;
	for(i=0; i<obj.length; i++)
	{
		//d = (obj[i].distanceTo(camera)/4000);			
		if(Number(text_xml.options[0].@pixel_fx)>0)
		{
			
		}    
	}
	*/
	camera.hover(1, view.containerSprite.mouseX/50, view.containerSprite.mouseY/50);            
	renderer.renderScene(scene, camera, view);

	//if(o){Output.trace("heartbeat");};
}